﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WPF_XamDataChart_CategoryDateTimeAxis
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Loaded += MainWindow_Loaded;
        }

         void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
                     
            //DateTime time = DateTime.Now;
          
            for (var time = DateTime.Now; time < DateTime.Now.AddHours(2); time = time.AddMinutes(10))
            {  
                Items1.Add(new Item { Time = time, Value = time.Subtract(DateTime.Now).TotalSeconds });

                Items2.Add(new Item { Time = time, Value = 12 * 30 * 30 - time.Subtract(DateTime.Now).TotalSeconds });

                //if (Items2.Count == 200)
                //{
                //    Items2.RemoveAt(0);
                //}

                TimesMinutes.Add(time);
            }

            int indx = Items1.Count - 2;

            Items1[indx].Value = Double.NaN;
            //Items2[indx].Value = Double.NaN;           

            MessageBox.Show(TimesMinutes[indx].ToLongTimeString() + " - " + Items1[indx].Value.ToString() + " - " + Items2[indx].Value.ToString() + " - ");

            Items1.RemoveAt(indx);
            Items2.RemoveAt(indx);
            TimesMinutes.RemoveAt(indx);

            for (var time = DateTime.Now; time < DateTime.Now.AddHours(1); time = time.AddSeconds(10))
            {
                Items1a.Add(new Item { Time = time, Value = time.Subtract(DateTime.Now).TotalSeconds });

                Items2a.Add(new Item { Time = time, Value = 12 * 10 * 10 - time.Subtract(DateTime.Now).TotalSeconds });

                TimesSeconds.Add(time);
            }  

        }


         public ObservableCollection<DateTime> TimesMinutes
         {
             get { return (ObservableCollection<DateTime>)GetValue(TimesMinutesProperty); }
             set { SetValue(TimesMinutesProperty, value); }
         }

         // Using a DependencyProperty as the backing store for Times.  This enables animation, styling, binding, etc...
         public static readonly DependencyProperty TimesMinutesProperty =
             DependencyProperty.Register("TimesMinutes", typeof(ObservableCollection<DateTime>), typeof(MainWindow), new PropertyMetadata(new ObservableCollection<DateTime>()));
         
       
        public ObservableCollection<DateTime> TimesSeconds
        {
            get { return (ObservableCollection<DateTime>)GetValue(TimesSecondsProperty); }
            set { SetValue(TimesSecondsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Times.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TimesSecondsProperty =
            DependencyProperty.Register("TimesSeconds", typeof(ObservableCollection<DateTime>), typeof(MainWindow), new PropertyMetadata(new ObservableCollection<DateTime>()));        


        public ObservableCollection<Item> Items1
        {
            get { return (ObservableCollection<Item>)GetValue(Items1Property); }
            set { SetValue(Items1Property, value); }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Items1Property =
            DependencyProperty.Register("Items1", typeof(ObservableCollection<Item>), typeof(MainWindow), new PropertyMetadata(new ObservableCollection<Item>()));

        public ObservableCollection<Item> Items2
        {
            get { return (ObservableCollection<Item>)GetValue(Items2Property); }
            set { SetValue(Items2Property, value); }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Items2Property =
            DependencyProperty.Register("Items2", typeof(ObservableCollection<Item>), typeof(MainWindow), new PropertyMetadata(new ObservableCollection<Item>()));


        public ObservableCollection<Item> Items1a
        {
            get { return (ObservableCollection<Item>)GetValue(Items1aProperty); }
            set { SetValue(Items1aProperty, value); }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Items1aProperty =
            DependencyProperty.Register("Items1a", typeof(ObservableCollection<Item>), typeof(MainWindow), new PropertyMetadata(new ObservableCollection<Item>()));

        public ObservableCollection<Item> Items2a
        {
            get { return (ObservableCollection<Item>)GetValue(Items2aProperty); }
            set { SetValue(Items2aProperty, value); }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Items2aProperty =
            DependencyProperty.Register("Items2a", typeof(ObservableCollection<Item>), typeof(MainWindow), new PropertyMetadata(new ObservableCollection<Item>()));
    }

    public class Item
    {
        public DateTime Time { get; set; }
        public double Value { get; set; }
    }
}

